diff -u --recursive --new-file asterisk/apps/app_dial.c.progress asterisk/apps/app_dial.c
--- asterisk/apps/app_dial.c.progress	Mon Dec  1 14:17:46 2003
+++ asterisk/apps/app_dial.c	Mon Dec  1 14:48:02 2003
@@ -125,7 +125,7 @@
 	int ringind=0;
 	struct ast_channel *winner;
 	
-	single = (outgoing && !outgoing->next && !outgoing->musiconhold && !outgoing->ringbackonly);
+	single = (outgoing && !outgoing->next /*&& !outgoing->musiconhold && !outgoing->ringbackonly*/);
 	
 	if (single) {
 		/* Turn off hold music, etc */
@@ -135,11 +135,9 @@
 	}
 	
 	if (outgoing) {
-		moh = outgoing->musiconhold;
-		ringind = outgoing->ringbackonly;
-		if (outgoing->musiconhold) {
+		if ((moh = outgoing->musiconhold)) {
 			ast_moh_start(in, NULL);
-		} else if (outgoing->ringbackonly) {
+		} else if ((ringind = outgoing->ringbackonly)) {
 			ast_indicate(in, AST_CONTROL_RINGING);
 		}
 	}
@@ -263,7 +261,19 @@
 						case AST_CONTROL_PROGRESS:
 							if (option_verbose > 2)
 								ast_verbose ( VERBOSE_PREFIX_3 "%s is making progress passing it to %s\n", o->chan->name,in->name);
-							ast_indicate(in, AST_CONTROL_PROGRESS);
+							/* Progress tones bypassing is possible for peer-to-peer calls only */
+							if (single || (numlines - numbusies == 1)) {
+								/* Stop any indications to pass inband tones */
+								if (moh) {
+									ast_moh_stop(in);
+									moh = 0;
+								} else if (ringind) {
+									ast_indicate(in, -1);
+									rindind = 0;
+								}
+								/* Tell caller to start receiving channel */
+								ast_indicate(in, AST_CONTROL_PROGRESS);
+							}
 							break;
 						case AST_CONTROL_OFFHOOK:
 							/* Ignore going off hook */
@@ -277,11 +287,11 @@
 							ast_log(LOG_DEBUG, "Dunno what to do with control type %d\n", f->subclass);
 						}
 					} else if (single && (f->frametype == AST_FRAME_VOICE) && 
-								!(outgoing->ringbackonly || outgoing->musiconhold)) {
+								!(ringind || moh)) {
 						if (ast_write(in, f)) 
 							ast_log(LOG_WARNING, "Unable to forward frame\n");
 					} else if (single && (f->frametype == AST_FRAME_IMAGE) && 
-								!(outgoing->ringbackonly || outgoing->musiconhold)) {
+								!(ringind || moh)) {
 						if (ast_write(in, f))
 							ast_log(LOG_WARNING, "Unable to forward image\n");
 					}
@@ -330,6 +340,10 @@
 		ast_indicate(in, -1);
 	}
 
+	/* Answer caller channel immediately if it not in UP state */
+	if(peer && (in->_state != AST_STATE_UP))
+		ast_answer(in);
+
 	return peer;
 	
 }
